/[gentoo-x86]/eclass/git-r3.eclass
Gentoo

Diff of /eclass/git-r3.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.6 Revision 1.41
1# Copyright 1999-2013 Gentoo Foundation 1# Copyright 1999-2014 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/git-r3.eclass,v 1.6 2013/09/19 09:37:14 mgorny Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/git-r3.eclass,v 1.41 2014/04/17 20:28:37 mgorny Exp $
4 4
5# @ECLASS: git-r3.eclass 5# @ECLASS: git-r3.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Michał Górny <mgorny@gentoo.org> 7# Michał Górny <mgorny@gentoo.org>
8# @BLURB: Eclass for fetching and unpacking git repositories. 8# @BLURB: Eclass for fetching and unpacking git repositories.
9# @DESCRIPTION: 9# @DESCRIPTION:
10# Third generation eclass for easing maitenance of live ebuilds using 10# Third generation eclass for easing maitenance of live ebuilds using
11# git as remote repository. The eclass supports lightweight (shallow) 11# git as remote repository.
12# clones and bare clones of submodules.
13 12
14case "${EAPI:-0}" in 13case "${EAPI:-0}" in
15 0|1|2|3|4|5) 14 0|1|2|3|4|5)
16 ;; 15 ;;
17 *) 16 *)
27 26
28EXPORT_FUNCTIONS src_unpack 27EXPORT_FUNCTIONS src_unpack
29 28
30if [[ ! ${_GIT_R3} ]]; then 29if [[ ! ${_GIT_R3} ]]; then
31 30
31if [[ ! ${_INHERITED_BY_GIT_2} ]]; then
32 DEPEND=">=dev-vcs/git-1.8.2.1"
33fi
34
35# @ECLASS-VARIABLE: EGIT_CLONE_TYPE
36# @DESCRIPTION:
37# Type of clone that should be used against the remote repository.
38# This can be either of: 'mirror', 'single', 'shallow'.
39#
40# This is intended to be set by user in make.conf. Ebuilds are supposed
41# to set EGIT_MIN_CLONE_TYPE if necessary instead.
42#
43# The 'mirror' type clones all remote branches and tags with complete
44# history and all notes. EGIT_COMMIT can specify any commit hash.
45# Upstream-removed branches and tags are purged from the local clone
46# while fetching. This mode is suitable for cloning the local copy
47# for development or hosting a local git mirror. However, clones
48# of repositories with large diverged branches may quickly grow large.
49#
50# The 'single+tags' type clones the requested branch and all tags
51# in the repository. All notes are fetched as well. EGIT_COMMIT
52# can safely specify hashes throughout the current branch and all tags.
53# No purging of old references is done (if you often switch branches,
54# you may need to remove stale branches yourself). This mode is intended
55# mostly for use with broken git servers such as Google Code that fail
56# to fetch tags along with the branch in 'single' mode.
57#
58# The 'single' type clones only the requested branch or tag. Tags
59# referencing commits throughout the branch history are fetched as well,
60# and all notes. EGIT_COMMIT can safely specify only hashes
61# in the current branch. No purging of old references is done (if you
62# often switch branches, you may need to remove stale branches
63# yourself). This mode is suitable for general use.
64#
65# The 'shallow' type clones only the newest commit on requested branch
66# or tag. EGIT_COMMIT can only specify tags, and since the history is
67# unavailable calls like 'git describe' will not reference prior tags.
68# No purging of old references is done. This mode is intended mostly for
69# embedded systems with limited disk space.
70: ${EGIT_CLONE_TYPE:=single}
71
72# @ECLASS-VARIABLE: EGIT_MIN_CLONE_TYPE
73# @DESCRIPTION:
74# 'Minimum' clone type supported by the ebuild. Takes same values
75# as EGIT_CLONE_TYPE. When user sets a type that's 'lower' (that is,
76# later on the list) than EGIT_MIN_CLONE_TYPE, the eclass uses
77# EGIT_MIN_CLONE_TYPE instead.
78#
79# This variable is intended to be used by ebuilds only. Users are
80# supposed to set EGIT_CLONE_TYPE instead.
81#
82# A common case is to use 'single' whenever the build system requires
83# access to full branch history, or 'single+tags' when Google Code
84# or a similar remote is used that does not support shallow clones
85# and fetching tags along with commits. Please use sparingly, and to fix
86# fatal errors rather than 'non-pretty versions'.
87: ${EGIT_MIN_CLONE_TYPE:=shallow}
88
32# @ECLASS-VARIABLE: EGIT3_STORE_DIR 89# @ECLASS-VARIABLE: EGIT3_STORE_DIR
33# @DESCRIPTION: 90# @DESCRIPTION:
34# Storage directory for git sources. 91# Storage directory for git sources.
35# 92#
93# This is intended to be set by user in make.conf. Ebuilds must not set
94# it.
95#
36# EGIT3_STORE_DIR=${DISTDIR}/git3-src 96# EGIT3_STORE_DIR=${DISTDIR}/git3-src
97
98# @ECLASS-VARIABLE: EGIT_MIRROR_URI
99# @DEFAULT_UNSET
100# @DESCRIPTION:
101# 'Top' URI to a local git mirror. If specified, the eclass will try
102# to fetch from the local mirror instead of using the remote repository.
103#
104# The mirror needs to follow EGIT3_STORE_DIR structure. The directory
105# created by eclass can be used for that purpose.
106#
107# Example:
108# @CODE
109# EGIT_MIRROR_URI="git://mirror.lan/"
110# @CODE
37 111
38# @ECLASS-VARIABLE: EGIT_REPO_URI 112# @ECLASS-VARIABLE: EGIT_REPO_URI
39# @REQUIRED 113# @REQUIRED
40# @DESCRIPTION: 114# @DESCRIPTION:
41# URIs to the repository, e.g. git://foo, https://foo. If multiple URIs 115# URIs to the repository, e.g. git://foo, https://foo. If multiple URIs
42# are provided, the eclass will consider them as fallback URIs to try 116# are provided, the eclass will consider them as fallback URIs to try
43# if the first URI does not work. 117# if the first URI does not work.
44# 118#
45# It can be overriden via env using ${PN}_LIVE_REPO variable. 119# It can be overriden via env using ${PN}_LIVE_REPO variable.
120#
121# Can be a whitespace-separated list or an array.
46# 122#
47# Example: 123# Example:
48# @CODE 124# @CODE
49# EGIT_REPO_URI="git://a/b.git https://c/d.git" 125# EGIT_REPO_URI="git://a/b.git https://c/d.git"
50# @CODE 126# @CODE
75# @DESCRIPTION: 151# @DESCRIPTION:
76# The directory to check the git sources out to. 152# The directory to check the git sources out to.
77# 153#
78# EGIT_CHECKOUT_DIR=${WORKDIR}/${P} 154# EGIT_CHECKOUT_DIR=${WORKDIR}/${P}
79 155
80# @ECLASS-VARIABLE: EGIT_NONSHALLOW
81# @DEFAULT_UNSET
82# @DESCRIPTION:
83# Disable performing shallow fetches/clones. Shallow clones have
84# a fair number of limitations. Therefore, if you'd like the eclass to
85# perform complete clones instead, set this to a non-null value.
86#
87# This variable is to be set in make.conf. Ebuilds are not allowed
88# to set it.
89
90# @FUNCTION: _git-r3_env_setup 156# @FUNCTION: _git-r3_env_setup
91# @INTERNAL 157# @INTERNAL
92# @DESCRIPTION: 158# @DESCRIPTION:
93# Set the eclass variables as necessary for operation. This can involve 159# Set the eclass variables as necessary for operation. This can involve
94# setting EGIT_* to defaults or ${PN}_LIVE_* variables. 160# setting EGIT_* to defaults or ${PN}_LIVE_* variables.
95_git-r3_env_setup() { 161_git-r3_env_setup() {
96 debug-print-function ${FUNCNAME} "$@" 162 debug-print-function ${FUNCNAME} "$@"
163
164 # check the clone type
165 case "${EGIT_CLONE_TYPE}" in
166 mirror|single+tags|single|shallow)
167 ;;
168 *)
169 die "Invalid EGIT_CLONE_TYPE=${EGIT_CLONE_TYPE}"
170 esac
171 case "${EGIT_MIN_CLONE_TYPE}" in
172 shallow)
173 ;;
174 single)
175 if [[ ${EGIT_CLONE_TYPE} == shallow ]]; then
176 einfo "git-r3: ebuild needs to be cloned in 'single' mode, adjusting"
177 EGIT_CLONE_TYPE=single
178 fi
179 ;;
180 single+tags)
181 if [[ ${EGIT_CLONE_TYPE} == shallow || ${EGIT_CLONE_TYPE} == single ]]; then
182 einfo "git-r3: ebuild needs to be cloned in 'single+tags' mode, adjusting"
183 EGIT_CLONE_TYPE=single+tags
184 fi
185 ;;
186 mirror)
187 if [[ ${EGIT_CLONE_TYPE} != mirror ]]; then
188 einfo "git-r3: ebuild needs to be cloned in 'mirror' mode, adjusting"
189 EGIT_CLONE_TYPE=mirror
190 fi
191 ;;
192 *)
193 die "Invalid EGIT_MIN_CLONE_TYPE=${EGIT_MIN_CLONE_TYPE}"
194 esac
97 195
98 local esc_pn livevar 196 local esc_pn livevar
99 esc_pn=${PN//[-+]/_} 197 esc_pn=${PN//[-+]/_}
100 198
101 livevar=${esc_pn}_LIVE_REPO 199 livevar=${esc_pn}_LIVE_REPO
169_git-r3_set_gitdir() { 267_git-r3_set_gitdir() {
170 debug-print-function ${FUNCNAME} "$@" 268 debug-print-function ${FUNCNAME} "$@"
171 269
172 local repo_name=${1#*://*/} 270 local repo_name=${1#*://*/}
173 271
272 # strip the trailing slash
273 repo_name=${repo_name%/}
274
174 # strip common prefixes to make paths more likely to match 275 # strip common prefixes to make paths more likely to match
175 # e.g. git://X/Y.git vs https://X/git/Y.git 276 # e.g. git://X/Y.git vs https://X/git/Y.git
176 # (but just one of the prefixes) 277 # (but just one of the prefixes)
177 case "${repo_name}" in 278 case "${repo_name}" in
279 # gnome.org... who else?
280 browse/*) repo_name=${repo_name#browse/};;
178 # cgit can proxy requests to git 281 # cgit can proxy requests to git
179 cgit/*) repo_name=${repo_name#cgit/};; 282 cgit/*) repo_name=${repo_name#cgit/};;
180 # pretty common 283 # pretty common
181 git/*) repo_name=${repo_name#git/};; 284 git/*) repo_name=${repo_name#git/};;
182 # gentoo.org 285 # gentoo.org
197 GIT_DIR=${EGIT3_STORE_DIR}/${repo_name} 300 GIT_DIR=${EGIT3_STORE_DIR}/${repo_name}
198 301
199 if [[ ! -d ${EGIT3_STORE_DIR} ]]; then 302 if [[ ! -d ${EGIT3_STORE_DIR} ]]; then
200 ( 303 (
201 addwrite / 304 addwrite /
202 mkdir -m0755 -p "${EGIT3_STORE_DIR}" 305 mkdir -m0755 -p "${EGIT3_STORE_DIR}" || die
203 ) || die "Unable to create ${EGIT3_STORE_DIR}" 306 ) || die "Unable to create ${EGIT3_STORE_DIR}"
204 fi 307 fi
205 308
206 addwrite "${EGIT3_STORE_DIR}" 309 addwrite "${EGIT3_STORE_DIR}"
207 if [[ ! -d ${GIT_DIR} ]]; then 310 if [[ ! -d ${GIT_DIR} ]]; then
208 mkdir "${GIT_DIR}" || die 311 mkdir "${GIT_DIR}" || die
209 git init --bare || die 312 git init --bare || die
210
211 if [[ ! ${EGIT_NONSHALLOW} ]]; then
212 # avoid auto-unshallow :)
213 touch "${GIT_DIR}"/shallow || die
214 fi
215 fi 313 fi
216} 314}
217 315
218# @FUNCTION: _git-r3_set_submodules 316# @FUNCTION: _git-r3_set_submodules
219# @USAGE: <file-contents> 317# @USAGE: <file-contents>
237 [[ ${l} == submodule.*.url=* ]] || continue 335 [[ ${l} == submodule.*.url=* ]] || continue
238 336
239 l=${l#submodule.} 337 l=${l#submodule.}
240 local subname=${l%%.url=*} 338 local subname=${l%%.url=*}
241 339
340 # skip modules that have 'update = none', bug #487262.
341 local upd=$(echo "${data}" | git config -f /dev/fd/0 \
342 submodule."${subname}".update)
343 [[ ${upd} == none ]] && continue
344
242 submodules+=( 345 submodules+=(
243 "${subname}" 346 "${subname}"
244 "$(echo "${data}" | git config -f /dev/fd/0 \ 347 "$(echo "${data}" | git config -f /dev/fd/0 \
245 submodule."${subname}".url)" 348 submodule."${subname}".url || die)"
246 "$(echo "${data}" | git config -f /dev/fd/0 \ 349 "$(echo "${data}" | git config -f /dev/fd/0 \
247 submodule."${subname}".path)" 350 submodule."${subname}".path || die)"
248 ) 351 )
249 done < <(echo "${data}" | git config -f /dev/fd/0 -l) 352 done < <(echo "${data}" | git config -f /dev/fd/0 -l || die)
250} 353}
251 354
252# @FUNCTION: _git-r3_smart_fetch 355# @FUNCTION: _git-r3_is_local_repo
253# @USAGE: <git-fetch-args>... 356# @USAGE: <repo-uri>
357# @INTERNAL
254# @DESCRIPTION: 358# @DESCRIPTION:
255# Try fetching without '--depth' and switch to '--depth 1' if that 359# Determine whether the given URI specifies a local (on-disk)
256# will involve less objects fetched. 360# repository.
257_git-r3_smart_fetch() { 361_git-r3_is_local_repo() {
258 debug-print-function ${FUNCNAME} "$@" 362 debug-print-function ${FUNCNAME} "$@"
259 363
260 local sed_regexp='.*Counting objects: \([0-9]*\), done\..*' 364 local uri=${1}
261 365
262 # start the main fetch 366 [[ ${uri} == file://* || ${uri} == /* ]]
263 local cmd=( git fetch --progress "${@}" ) 367}
264 echo "${cmd[@]}" >&2
265 368
266 # we copy the output to the 'sed' pipe for parsing. whenever sed finds 369# @FUNCTION: _git-r3_find_head
267 # the process count, it quits quickly to avoid delays in writing it. 370# @USAGE: <head-ref>
268 # then, we start a dummy 'cat' to keep the pipe alive 371# @INTERNAL
372# @DESCRIPTION:
373# Given a ref to which remote HEAD was fetched, try to find
374# a branch matching the commit. Expects 'git show-ref'
375# or 'git ls-remote' output on stdin.
376_git-r3_find_head() {
377 debug-print-function ${FUNCNAME} "$@"
269 378
270 "${cmd[@]}" 2>&1 \ 379 local head_ref=${1}
271 | tee >( 380 local head_hash=$(git rev-parse --verify "${1}" || die)
272 sed -n -e "/${sed_regexp}/{s/${sed_regexp}/\1/p;q}" \ 381 local matching_ref
273 > "${T}"/git-r3_main.count
274 exec cat >/dev/null
275 ) &
276 local main_pid=${!}
277 382
278 # start the helper process 383 # TODO: some transports support peeking at symbolic remote refs
279 _git-r3_sub_fetch() { 384 # find a way to use that rather than guessing
280 # wait for main fetch to get object count; if the server doesn't 385
281 # output it, we won't even launch the parallel process 386 # (based on guess_remote_head() in git-1.9.0/remote.c)
282 while [[ ! -s ${T}/git-r3_main.count ]]; do 387 local h ref
283 sleep 0.25 388 while read h ref; do
389 # look for matching head
390 if [[ ${h} == ${head_hash} ]]; then
391 # either take the first matching ref, or master if it is there
392 if [[ ! ${matching_ref} || ${ref} == refs/heads/master ]]; then
393 matching_ref=${ref}
394 fi
395 fi
284 done 396 done
285 397
286 # ok, let's see if parallel fetch gives us smaller count 398 if [[ ! ${matching_ref} ]]; then
287 # --dry-run will prevent it from writing to the local clone 399 die "Unable to find a matching branch for remote HEAD (${head_hash})"
288 # and sed should terminate git with SIGPIPE
289 local sub_count=$(git fetch --progress --dry-run --depth 1 "${@}" 2>&1 \
290 | sed -n -e "/${sed_regexp}/{s/${sed_regexp}/\1/p;q}")
291 local main_count=$(<"${T}"/git-r3_main.count)
292
293 # let's be real sure that '--depth 1' will be good for us.
294 # note that we have purely objects counts, and '--depth 1'
295 # may involve much bigger objects
296 if [[ ${main_count} && ${main_count} -ge $(( sub_count * 3/2 )) ]]
297 then
298 # signal that we want shallow fetch instead,
299 # and terminate the non-shallow fetch process
300 touch "${T}"/git-r3_want_shallow || die
301 kill ${main_pid} &>/dev/null
302 exit 0
303 fi 400 fi
304 401
305 exit 1 402 echo "${matching_ref}"
306 }
307 _git-r3_sub_fetch "${@}" &
308 local sub_pid=${!}
309
310 # wait for main process to terminate, either of its own
311 # or by signal from subprocess
312 wait ${main_pid}
313 local main_ret=${?}
314
315 # wait for subprocess to terminate, killing it if necessary.
316 # if main fetch finished before it, there's no point in keeping
317 # it alive. if main fetch was killed by it, it's done anyway
318 kill ${sub_pid} &>/dev/null
319 wait ${sub_pid}
320
321 # now see if subprocess wanted to tell us something...
322 if [[ -f ${T}/git-r3_want_shallow ]]; then
323 rm "${T}"/git-r3_want_shallow || die
324
325 # if fetch finished already (wasn't killed), ignore it
326 [[ ${main_ret} -eq 0 ]] && return 0
327
328 # otherwise, restart as shallow fetch
329 einfo "Restarting fetch using --depth 1 to save bandwidth ..."
330 local cmd=( git fetch --progress --depth 1 "${@}" )
331 echo "${cmd[@]}" >&2
332 "${cmd[@]}"
333 main_ret=${?}
334 fi
335
336 return ${main_ret}
337} 403}
338 404
339# @FUNCTION: git-r3_fetch 405# @FUNCTION: git-r3_fetch
340# @USAGE: [<repo-uri> [<remote-ref> [<local-id>]]] 406# @USAGE: [<repo-uri> [<remote-ref> [<local-id>]]]
341# @DESCRIPTION: 407# @DESCRIPTION:
354# is set to a non-null value. 420# is set to a non-null value.
355# 421#
356# <local-id> specifies the local branch identifier that will be used to 422# <local-id> specifies the local branch identifier that will be used to
357# locally store the fetch result. It should be unique to multiple 423# locally store the fetch result. It should be unique to multiple
358# fetches within the repository that can be performed at the same time 424# fetches within the repository that can be performed at the same time
359# (including parallel merges). It defaults to ${CATEGORY}/${PN}/${SLOT}. 425# (including parallel merges). It defaults to ${CATEGORY}/${PN}/${SLOT%/*}.
360# This default should be fine unless you are fetching multiple trees 426# This default should be fine unless you are fetching multiple trees
361# from the same repository in the same ebuild. 427# from the same repository in the same ebuild.
362# 428#
363# The fetch operation will affect the EGIT_STORE only. It will not touch 429# The fetch operation will affect the EGIT_STORE only. It will not touch
364# the working copy, nor export any environment variables. 430# the working copy, nor export any environment variables.
365# If the repository contains submodules, they will be fetched 431# If the repository contains submodules, they will be fetched
366# recursively. 432# recursively.
367git-r3_fetch() { 433git-r3_fetch() {
368 debug-print-function ${FUNCNAME} "$@" 434 debug-print-function ${FUNCNAME} "$@"
369 435
436 [[ ${EVCS_OFFLINE} ]] && return
437
438 local repos
439 if [[ ${1} ]]; then
440 repos=( ${1} )
441 elif [[ $(declare -p EGIT_REPO_URI) == "declare -a"* ]]; then
442 repos=( "${EGIT_REPO_URI[@]}" )
443 else
370 local repos=( ${1:-${EGIT_REPO_URI}} ) 444 repos=( ${EGIT_REPO_URI} )
445 fi
446
371 local branch=${EGIT_BRANCH:+refs/heads/${EGIT_BRANCH}} 447 local branch=${EGIT_BRANCH:+refs/heads/${EGIT_BRANCH}}
372 local remote_ref=${2:-${EGIT_COMMIT:-${branch:-HEAD}}} 448 local remote_ref=${2:-${EGIT_COMMIT:-${branch:-HEAD}}}
373 local local_id=${3:-${CATEGORY}/${PN}/${SLOT}} 449 local local_id=${3:-${CATEGORY}/${PN}/${SLOT%/*}}
374 local local_ref=refs/heads/${local_id}/__main__ 450 local local_ref=refs/git-r3/${local_id}/__main__
375 451
376 [[ ${repos[@]} ]] || die "No URI provided and EGIT_REPO_URI unset" 452 [[ ${repos[@]} ]] || die "No URI provided and EGIT_REPO_URI unset"
377 453
378 local -x GIT_DIR 454 local -x GIT_DIR
379 _git-r3_set_gitdir ${repos[0]} 455 _git-r3_set_gitdir "${repos[0]}"
456
457 # prepend the local mirror if applicable
458 if [[ ${EGIT_MIRROR_URI} ]]; then
459 repos=(
460 "${EGIT_MIRROR_URI%/}/${GIT_DIR##*/}"
461 "${repos[@]}"
462 )
463 fi
380 464
381 # try to fetch from the remote 465 # try to fetch from the remote
382 local r success 466 local r success
383 for r in ${repos[@]}; do 467 for r in "${repos[@]}"; do
468 einfo "Fetching ${r} ..."
469
470 local fetch_command=( git fetch "${r}" )
471 local clone_type=${EGIT_CLONE_TYPE}
472
473 if [[ ${r} == https://code.google.com/* ]]; then
474 # Google Code has special magic on top of git that:
475 # 1) can't handle shallow clones at all,
476 # 2) fetches duplicately when tags are pulled in with branch
477 # so automatically switch to single+tags mode.
478 if [[ ${clone_type} == shallow ]]; then
479 einfo " Google Code does not support shallow clones"
480 einfo " using EGIT_CLONE_TYPE=single+tags"
481 clone_type=single+tags
482 elif [[ ${clone_type} == single ]]; then
483 einfo " git-r3: Google Code does not send tags properly in 'single' mode"
484 einfo " using EGIT_CLONE_TYPE=single+tags"
485 clone_type=single+tags
486 fi
487 fi
488
489 if [[ ${clone_type} == mirror ]]; then
490 fetch_command+=(
491 --prune
492 # mirror the remote branches as local branches
493 "+refs/heads/*:refs/heads/*"
494 # pull tags explicitly in order to prune them properly
495 "+refs/tags/*:refs/tags/*"
496 # notes in case something needs them
497 "+refs/notes/*:refs/notes/*"
498 # and HEAD in case we need the default branch
499 # (we keep it in refs/git-r3 since otherwise --prune interferes)
500 "+HEAD:refs/git-r3/HEAD"
501 )
502 else # single or shallow
503 local fetch_l fetch_r
504
505 if [[ ${remote_ref} == HEAD ]]; then
506 # HEAD
507 fetch_l=HEAD
508 elif [[ ${remote_ref} == refs/heads/* ]]; then
509 # regular branch
510 fetch_l=${remote_ref}
511 else
512 # tag or commit...
513 # let ls-remote figure it out
514 local tagref=$(git ls-remote "${r}" "refs/tags/${remote_ref}")
515
516 # if it was a tag, ls-remote obtained a hash
517 if [[ ${tagref} ]]; then
518 # tag
519 fetch_l=refs/tags/${remote_ref}
520 else
521 # commit
522 # so we need to fetch the branch
523 if [[ ${branch} ]]; then
524 fetch_l=${branch}
525 else
526 fetch_l=HEAD
527 fi
528
529 # fetching by commit in shallow mode? can't do.
530 if [[ ${clone_type} == shallow ]]; then
531 clone_type=single
532 fi
533 fi
534 fi
535
536 if [[ ${fetch_l} == HEAD ]]; then
537 fetch_r=refs/git-r3/HEAD
538 else
539 fetch_r=${fetch_l}
540 fi
541
542 fetch_command+=(
543 "+${fetch_l}:${fetch_r}"
544 )
545
546 if [[ ${clone_type} == single+tags ]]; then
547 fetch_command+=(
548 # pull tags explicitly as requested
549 "+refs/tags/*:refs/tags/*"
550 )
551 fi
552 fi
553
554 if [[ ${clone_type} == shallow ]]; then
555 if _git-r3_is_local_repo; then
556 # '--depth 1' causes sandbox violations with local repos
557 # bug #491260
558 clone_type=single
559 elif [[ ! $(git rev-parse --quiet --verify "${fetch_r}") ]]
560 then
561 # use '--depth 1' when fetching a new branch
562 fetch_command+=( --depth 1 )
563 fi
564 else # non-shallow mode
565 if [[ -f ${GIT_DIR}/shallow ]]; then
566 fetch_command+=( --unshallow )
567 fi
568 fi
569
570 set -- "${fetch_command[@]}"
571 echo "${@}" >&2
572 if "${@}"; then
573 if [[ ${clone_type} == mirror ]]; then
574 # find remote HEAD and update our HEAD properly
575 git symbolic-ref HEAD \
576 "$(_git-r3_find_head refs/git-r3/HEAD \
577 < <(git show-ref --heads || die))" \
578 || die "Unable to update HEAD"
579 else # single or shallow
580 if [[ ${fetch_l} == HEAD ]]; then
581 # find out what branch we fetched as HEAD
582 local head_branch=$(_git-r3_find_head \
583 refs/git-r3/HEAD \
584 < <(git ls-remote --heads "${r}" || die))
585
586 # and move it to its regular place
587 git update-ref --no-deref "${head_branch}" \
588 refs/git-r3/HEAD \
589 || die "Unable to sync HEAD branch ${head_branch}"
590 git symbolic-ref HEAD "${head_branch}" \
591 || die "Unable to update HEAD"
592 fi
593 fi
594
595 # now let's see what the user wants from us
596 local full_remote_ref=$(
597 git rev-parse --verify --symbolic-full-name "${remote_ref}"
598 )
599
600 if [[ ${full_remote_ref} ]]; then
601 # when we are given a ref, create a symbolic ref
602 # so that we preserve the actual argument
603 set -- git symbolic-ref "${local_ref}" "${full_remote_ref}"
604 else
605 # otherwise, we were likely given a commit id
606 set -- git update-ref --no-deref "${local_ref}" "${remote_ref}"
607 fi
608
609 echo "${@}" >&2
610 if ! "${@}"; then
611 die "Referencing ${remote_ref} failed (wrong ref?)."
612 fi
613
614 success=1
615 break
616 fi
617 done
618 [[ ${success} ]] || die "Unable to fetch from any of EGIT_REPO_URI"
619
620 # submodules can reference commits in any branch
621 # always use the 'clone' mode to accomodate that, bug #503332
622 local EGIT_CLONE_TYPE=mirror
623
624 # recursively fetch submodules
625 if git cat-file -e "${local_ref}":.gitmodules &>/dev/null; then
626 local submodules
627 _git-r3_set_submodules \
628 "$(git cat-file -p "${local_ref}":.gitmodules || die)"
629
630 while [[ ${submodules[@]} ]]; do
631 local subname=${submodules[0]}
632 local url=${submodules[1]}
633 local path=${submodules[2]}
634 local commit=$(git rev-parse "${local_ref}:${path}")
635
636 if [[ ! ${commit} ]]; then
637 die "Unable to get commit id for submodule ${subname}"
638 fi
639 if [[ ${url} == ./* || ${url} == ../* ]]; then
640 local subrepos=( "${repos[@]/%//${url}}" )
641 else
642 local subrepos=( "${url}" )
643 fi
644
645 git-r3_fetch "${subrepos[*]}" "${commit}" "${local_id}/${subname}"
646
647 submodules=( "${submodules[@]:3}" ) # shift
648 done
649 fi
650}
651
652# @FUNCTION: git-r3_checkout
653# @USAGE: [<repo-uri> [<checkout-path> [<local-id>]]]
654# @DESCRIPTION:
655# Check the previously fetched tree to the working copy.
656#
657# <repo-uri> specifies the repository URIs, as a space-separated list.
658# The first URI will be used as repository group identifier
659# and therefore must be used consistently with git-r3_fetch.
660# The remaining URIs are not used and therefore may be omitted.
661# When not specified, defaults to ${EGIT_REPO_URI}.
662#
663# <checkout-path> specifies the path to place the checkout. It defaults
664# to ${EGIT_CHECKOUT_DIR} if set, otherwise to ${WORKDIR}/${P}.
665#
666# <local-id> needs to specify the local identifier that was used
667# for respective git-r3_fetch.
668#
669# The checkout operation will write to the working copy, and export
670# the repository state into the environment. If the repository contains
671# submodules, they will be checked out recursively.
672git-r3_checkout() {
673 debug-print-function ${FUNCNAME} "$@"
674
675 local repos
676 if [[ ${1} ]]; then
677 repos=( ${1} )
678 elif [[ $(declare -p EGIT_REPO_URI) == "declare -a"* ]]; then
679 repos=( "${EGIT_REPO_URI[@]}" )
680 else
681 repos=( ${EGIT_REPO_URI} )
682 fi
683
684 local out_dir=${2:-${EGIT_CHECKOUT_DIR:-${WORKDIR}/${P}}}
685 local local_id=${3:-${CATEGORY}/${PN}/${SLOT%/*}}
686
687 local -x GIT_DIR
688 _git-r3_set_gitdir "${repos[0]}"
689
690 einfo "Checking out ${repos[0]} to ${out_dir} ..."
691
692 if ! git cat-file -e refs/git-r3/"${local_id}"/__main__; then
693 if [[ ${EVCS_OFFLINE} ]]; then
694 die "No local clone of ${repos[0]}. Unable to work with EVCS_OFFLINE."
695 else
696 die "Logic error: no local clone of ${repos[0]}. git-r3_fetch not used?"
697 fi
698 fi
699 local remote_ref=$(
700 git symbolic-ref --quiet refs/git-r3/"${local_id}"/__main__
701 )
702 local new_commit_id=$(
703 git rev-parse --verify refs/git-r3/"${local_id}"/__main__
704 )
705
706 git-r3_sub_checkout() {
707 local orig_repo=${GIT_DIR}
708 local -x GIT_DIR=${out_dir}/.git
709 local -x GIT_WORK_TREE=${out_dir}
710
711 mkdir -p "${out_dir}" || die
712
713 # use git init+fetch instead of clone since the latter doesn't like
714 # non-empty directories.
715
716 git init --quiet || die
717 # setup 'alternates' to avoid copying objects
718 echo "${orig_repo}/objects" > "${GIT_DIR}"/objects/info/alternates || die
719 # now copy the refs
720 # [htn]* safely catches heads, tags, notes without complaining
721 # on non-existing ones, and omits internal 'git-r3' ref
722 cp -R "${orig_repo}"/refs/[htn]* "${GIT_DIR}"/refs/ || die
723
724 # (no need to copy HEAD, we will set it via checkout)
725
726 if [[ -f ${orig_repo}/shallow ]]; then
727 cp "${orig_repo}"/shallow "${GIT_DIR}"/ || die
728 fi
729
730 set -- git checkout --quiet
731 if [[ ${remote_ref} ]]; then
732 set -- "${@}" "${remote_ref#refs/heads/}"
733 else
734 set -- "${@}" "${new_commit_id}"
735 fi
736 echo "${@}" >&2
737 "${@}" || die "git checkout ${remote_ref:-${new_commit_id}} failed"
738 }
739 git-r3_sub_checkout
740
741 local old_commit_id=$(
742 git rev-parse --quiet --verify refs/git-r3/"${local_id}"/__old__
743 )
744 if [[ ! ${old_commit_id} ]]; then
745 echo "GIT NEW branch -->"
746 echo " repository: ${repos[0]}"
747 echo " at the commit: ${new_commit_id}"
748 else
749 # diff against previous revision
750 echo "GIT update -->"
751 echo " repository: ${repos[0]}"
752 # write out message based on the revisions
753 if [[ "${old_commit_id}" != "${new_commit_id}" ]]; then
754 echo " updating from commit: ${old_commit_id}"
755 echo " to commit: ${new_commit_id}"
756
757 git --no-pager diff --stat \
758 ${old_commit_id}..${new_commit_id}
759 else
760 echo " at the commit: ${new_commit_id}"
761 fi
762 fi
763 git update-ref --no-deref refs/git-r3/"${local_id}"/{__old__,__main__} || die
764
765 # recursively checkout submodules
766 if [[ -f ${out_dir}/.gitmodules ]]; then
767 local submodules
768 _git-r3_set_submodules \
769 "$(<"${out_dir}"/.gitmodules)"
770
771 while [[ ${submodules[@]} ]]; do
772 local subname=${submodules[0]}
773 local url=${submodules[1]}
774 local path=${submodules[2]}
775
776 if [[ ${url} == ./* || ${url} == ../* ]]; then
777 url=${repos[0]%%/}/${url}
778 fi
779
780 git-r3_checkout "${url}" "${out_dir}/${path}" \
781 "${local_id}/${subname}"
782
783 submodules=( "${submodules[@]:3}" ) # shift
784 done
785 fi
786
787 # keep this *after* submodules
788 export EGIT_DIR=${GIT_DIR}
789 export EGIT_VERSION=${new_commit_id}
790}
791
792# @FUNCTION: git-r3_peek_remote_ref
793# @USAGE: [<repo-uri> [<remote-ref>]]
794# @DESCRIPTION:
795# Peek the reference in the remote repository and print the matching
796# (newest) commit SHA1.
797#
798# <repo-uri> specifies the repository URIs to fetch from, as a space-
799# -separated list. When not specified, defaults to ${EGIT_REPO_URI}.
800#
801# <remote-ref> specifies the remote ref to peek. It is preferred to use
802# 'refs/heads/<branch-name>' for branches and 'refs/tags/<tag-name>'
803# for tags. Alternatively, 'HEAD' may be used for upstream default
804# branch. Defaults to the first of EGIT_COMMIT, EGIT_BRANCH or literal
805# 'HEAD' that is set to a non-null value.
806#
807# The operation will be done purely on the remote, without using local
808# storage. If commit SHA1 is provided as <remote-ref>, the function will
809# fail due to limitations of git protocol.
810#
811# On success, the function returns 0 and writes hexadecimal commit SHA1
812# to stdout. On failure, the function returns 1.
813git-r3_peek_remote_ref() {
814 debug-print-function ${FUNCNAME} "$@"
815
816 local repos
817 if [[ ${1} ]]; then
818 repos=( ${1} )
819 elif [[ $(declare -p EGIT_REPO_URI) == "declare -a"* ]]; then
820 repos=( "${EGIT_REPO_URI[@]}" )
821 else
822 repos=( ${EGIT_REPO_URI} )
823 fi
824
825 local branch=${EGIT_BRANCH:+refs/heads/${EGIT_BRANCH}}
826 local remote_ref=${2:-${EGIT_COMMIT:-${branch:-HEAD}}}
827
828 [[ ${repos[@]} ]] || die "No URI provided and EGIT_REPO_URI unset"
829
830 local r success
831 for r in "${repos[@]}"; do
384 einfo "Fetching ${remote_ref} from ${r} ..." 832 einfo "Peeking ${remote_ref} on ${r} ..." >&2
385 833
386 local is_branch lookup_ref 834 local is_branch lookup_ref
387 if [[ ${remote_ref} == refs/heads/* || ${remote_ref} == HEAD ]] 835 if [[ ${remote_ref} == refs/heads/* || ${remote_ref} == HEAD ]]
388 then 836 then
389 is_branch=1 837 is_branch=1
392 # ls-remote by commit is going to fail anyway, 840 # ls-remote by commit is going to fail anyway,
393 # so we may as well pass refs/tags/ABCDEF... 841 # so we may as well pass refs/tags/ABCDEF...
394 lookup_ref=refs/tags/${remote_ref} 842 lookup_ref=refs/tags/${remote_ref}
395 fi 843 fi
396 844
397 # first, try ls-remote to see if ${remote_ref} is a real ref
398 # and not a commit id. if it succeeds, we can pass ${remote_ref}
399 # to 'fetch'. otherwise, we will just fetch everything
400
401 # split on whitespace
402 local ref=(
403 $(git ls-remote "${r}" "${lookup_ref}" || echo __FAIL__)
404 )
405
406 # normally, ref[0] is a hash, so we can do magic strings here
407 [[ ${ref[0]} == __FAIL__ ]] && continue
408
409 local nonshallow=${EGIT_NONSHALLOW}
410 local ref_param=()
411 if [[ ! ${ref[0]} ]]; then
412 nonshallow=1
413 fi
414
415 # 1. if we need a non-shallow clone and we have a shallow one,
416 # we need to unshallow it explicitly.
417 # 2. if we want a shallow clone, we just pass '--depth 1'
418 # to the first fetch in the repo. passing '--depth'
419 # to further requests usually results in more data being
420 # downloaded than without it.
421 # 3. if we update a shallow clone, we try without '--depth'
422 # first since that usually transfers less data. however,
423 # we use git-r3_smart_fetch that can switch into '--depth 1'
424 # if that looks beneficial.
425
426 local fetch_command=( git fetch )
427 if [[ ${nonshallow} ]]; then
428 if [[ -f ${GIT_DIR}/shallow ]]; then
429 ref_param+=( --unshallow )
430 fi
431 else
432 # 'git show-ref --heads' returns 1 when there are no branches
433 if ! git show-ref --heads -q; then
434 ref_param+=( --depth 1 )
435 else
436 fetch_command=( _git-r3_smart_fetch )
437 fi
438 fi
439
440 # now, another important thing. we may only fetch a remote
441 # branch directly to a local branch. Otherwise, we need to fetch
442 # the commit and re-create the branch on top of it.
443
444 if [[ ${ref[0]} ]]; then
445 if [[ ${is_branch} ]]; then
446 ref_param+=( -f "${remote_ref}:${local_id}/__main__" )
447 else
448 ref_param+=( "refs/tags/${remote_ref}" )
449 fi
450 fi
451
452 # if ${remote_ref} is branch or tag, ${ref[@]} will contain
453 # the respective commit id. otherwise, it will be an empty
454 # array, so the following won't evaluate to a parameter.
455 set -- "${fetch_command[@]}" --no-tags "${r}" "${ref_param[@]}"
456 echo "${@}" >&2
457 if "${@}"; then
458 if [[ ! ${is_branch} ]]; then
459 set -- git branch -f "${local_id}/__main__" \
460 "${ref[0]:-${remote_ref}}"
461 echo "${@}" >&2
462 if ! "${@}"; then
463 die "Creating branch for ${remote_ref} failed (wrong ref?)."
464 fi
465 fi
466
467 success=1
468 break
469 fi
470 done
471 [[ ${success} ]] || die "Unable to fetch from any of EGIT_REPO_URI"
472
473 # recursively fetch submodules
474 if git cat-file -e "${local_ref}":.gitmodules &>/dev/null; then
475 local submodules
476 _git-r3_set_submodules \
477 "$(git cat-file -p "${local_ref}":.gitmodules || die)"
478
479 while [[ ${submodules[@]} ]]; do
480 local subname=${submodules[0]}
481 local url=${submodules[1]}
482 local path=${submodules[2]}
483 local commit=$(git rev-parse "${local_ref}:${path}")
484
485 if [[ ! ${commit} ]]; then
486 die "Unable to get commit id for submodule ${subname}"
487 fi
488
489 git-r3_fetch "${url}" "${commit}" "${local_id}/${subname}"
490
491 submodules=( "${submodules[@]:3}" ) # shift
492 done
493 fi
494}
495
496# @FUNCTION: git-r3_checkout
497# @USAGE: [<repo-uri> [<checkout-path> [<local-id>]]]
498# @DESCRIPTION:
499# Check the previously fetched tree to the working copy.
500#
501# <repo-uri> specifies the repository URIs, as a space-separated list.
502# The first URI will be used as repository group identifier
503# and therefore must be used consistently with git-r3_fetch.
504# The remaining URIs are not used and therefore may be omitted.
505# When not specified, defaults to ${EGIT_REPO_URI}.
506#
507# <checkout-path> specifies the path to place the checkout. It defaults
508# to ${EGIT_CHECKOUT_DIR} if set, otherwise to ${WORKDIR}/${P}.
509#
510# <local-id> needs to specify the local identifier that was used
511# for respective git-r3_fetch.
512#
513# The checkout operation will write to the working copy, and export
514# the repository state into the environment. If the repository contains
515# submodules, they will be checked out recursively.
516git-r3_checkout() {
517 debug-print-function ${FUNCNAME} "$@"
518
519 local repos=( ${1:-${EGIT_REPO_URI}} )
520 local out_dir=${2:-${EGIT_CHECKOUT_DIR:-${WORKDIR}/${P}}}
521 local local_id=${3:-${CATEGORY}/${PN}/${SLOT}}
522
523 local -x GIT_DIR GIT_WORK_TREE
524 _git-r3_set_gitdir ${repos[0]}
525 GIT_WORK_TREE=${out_dir}
526 mkdir -p "${GIT_WORK_TREE}"
527
528 einfo "Checking out ${repos[0]} to ${out_dir} ..."
529
530 if ! git cat-file -e refs/heads/"${local_id}"/__main__
531 then
532 if [[ ${EVCS_OFFLINE} ]]; then
533 die "No local clone of ${repos[0]}. Unable to work with EVCS_OFFLINE."
534 else
535 die "Logic error: no local clone of ${repos[0]}. git-r3_fetch not used?"
536 fi
537 fi
538
539 set -- git checkout -f "${local_id}"/__main__ .
540 echo "${@}" >&2
541 "${@}" || die "git checkout ${local_id}/__main__ failed"
542
543 # diff against previous revision (if any)
544 local new_commit_id=$(git rev-parse --verify "${local_id}"/__main__)
545 local old_commit_id=$(
546 git rev-parse --verify "${local_id}"/__old__ 2>/dev/null
547 )
548
549 if [[ ! ${old_commit_id} ]]; then
550 echo "GIT NEW branch -->"
551 echo " repository: ${repos[0]}"
552 echo " at the commit: ${new_commit_id}"
553 else
554 echo "GIT update -->"
555 echo " repository: ${repos[0]}"
556 # write out message based on the revisions
557 if [[ "${old_commit_id}" != "${new_commit_id}" ]]; then
558 echo " updating from commit: ${old_commit_id}"
559 echo " to commit: ${new_commit_id}"
560
561 git --no-pager diff --stat \
562 ${old_commit_id}..${new_commit_id}
563 else
564 echo " at the commit: ${new_commit_id}"
565 fi
566 fi
567 git branch -f "${local_id}"/{__old__,__main__} || die
568
569 # recursively checkout submodules
570 if [[ -f ${GIT_WORK_TREE}/.gitmodules ]]; then
571 local submodules
572 _git-r3_set_submodules \
573 "$(<"${GIT_WORK_TREE}"/.gitmodules)"
574
575 while [[ ${submodules[@]} ]]; do
576 local subname=${submodules[0]}
577 local url=${submodules[1]}
578 local path=${submodules[2]}
579
580 git-r3_checkout "${url}" "${GIT_WORK_TREE}/${path}" \
581 "${local_id}/${subname}"
582
583 submodules=( "${submodules[@]:3}" ) # shift
584 done
585 fi
586
587 # keep this *after* submodules
588 export EGIT_DIR=${GIT_DIR}
589 export EGIT_VERSION=${new_commit_id}
590}
591
592# @FUNCTION: git-r3_peek_remote_ref
593# @USAGE: [<repo-uri> [<remote-ref>]]
594# @DESCRIPTION:
595# Peek the reference in the remote repository and print the matching
596# (newest) commit SHA1.
597#
598# <repo-uri> specifies the repository URIs to fetch from, as a space-
599# -separated list. When not specified, defaults to ${EGIT_REPO_URI}.
600#
601# <remote-ref> specifies the remote ref to peek. It is preferred to use
602# 'refs/heads/<branch-name>' for branches and 'refs/tags/<tag-name>'
603# for tags. Alternatively, 'HEAD' may be used for upstream default
604# branch. Defaults to the first of EGIT_COMMIT, EGIT_BRANCH or literal
605# 'HEAD' that is set to a non-null value.
606#
607# The operation will be done purely on the remote, without using local
608# storage. If commit SHA1 is provided as <remote-ref>, the function will
609# fail due to limitations of git protocol.
610#
611# On success, the function returns 0 and writes hexadecimal commit SHA1
612# to stdout. On failure, the function returns 1.
613git-r3_peek_remote_ref() {
614 debug-print-function ${FUNCNAME} "$@"
615
616 local repos=( ${1:-${EGIT_REPO_URI}} )
617 local branch=${EGIT_BRANCH:+refs/heads/${EGIT_BRANCH}}
618 local remote_ref=${2:-${EGIT_COMMIT:-${branch:-HEAD}}}
619
620 [[ ${repos[@]} ]] || die "No URI provided and EGIT_REPO_URI unset"
621
622 local r success
623 for r in ${repos[@]}; do
624 einfo "Peeking ${remote_ref} on ${r} ..." >&2
625
626 local is_branch lookup_ref
627 if [[ ${remote_ref} == refs/heads/* || ${remote_ref} == HEAD ]]
628 then
629 is_branch=1
630 lookup_ref=${remote_ref}
631 else
632 # ls-remote by commit is going to fail anyway,
633 # so we may as well pass refs/tags/ABCDEF...
634 lookup_ref=refs/tags/${remote_ref}
635 fi
636
637 # split on whitespace 845 # split on whitespace
638 local ref=( 846 local ref=(
639 $(git ls-remote "${r}" "${lookup_ref}") 847 $(git ls-remote "${r}" "${lookup_ref}")
640 ) 848 )
641 849
648 return 1 856 return 1
649} 857}
650 858
651git-r3_src_fetch() { 859git-r3_src_fetch() {
652 debug-print-function ${FUNCNAME} "$@" 860 debug-print-function ${FUNCNAME} "$@"
653
654 [[ ${EVCS_OFFLINE} ]] && return
655 861
656 if [[ ! ${EGIT3_STORE_DIR} && ${EGIT_STORE_DIR} ]]; then 862 if [[ ! ${EGIT3_STORE_DIR} && ${EGIT_STORE_DIR} ]]; then
657 ewarn "You have set EGIT_STORE_DIR but not EGIT3_STORE_DIR. Please consider" 863 ewarn "You have set EGIT_STORE_DIR but not EGIT3_STORE_DIR. Please consider"
658 ewarn "setting EGIT3_STORE_DIR for git-r3.eclass. It is recommended to use" 864 ewarn "setting EGIT3_STORE_DIR for git-r3.eclass. It is recommended to use"
659 ewarn "a different directory than EGIT_STORE_DIR to ease removing old clones" 865 ewarn "a different directory than EGIT_STORE_DIR to ease removing old clones"

Legend:
Removed from v.1.6  
changed lines
  Added in v.1.41

  ViewVC Help
Powered by ViewVC 1.1.20